// {{{RME classifier 'Logical View::VANT::VCTRL::VCONT::Bus_Cont_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Bus_Cont_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Bus_Cont_Protocol.h>

const RTProtocolDescriptor Bus_Cont_Protocol::Base::rt_class =
{
	&PMission::Base::rt_class
  , &Bus_Cont_Protocol::Conjugate::rt_class
  , "Bus_Cont_Protocol"
  , 0
  , 7
  , Bus_Cont_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Bus_Cont_Protocol::Base::rt_signals[] =
{
	{
		"doAction"
	  , &RTType_MissionVant
	  , Bus_Cont_Protocol::Base::rti_doAction
	}
  , {
		"requestMission"
	  , &RTType_MissionVant
	  , Bus_Cont_Protocol::Base::rti_requestMission
	}
  , {
		"request_controle_status"
	  , &RTType_void
	  , Bus_Cont_Protocol::Base::rti_request_controle_status
	}
  , {
		"request_destination"
	  , &RTType_void
	  , Bus_Cont_Protocol::Base::rti_request_destination
	}
  , {
		"request_position"
	  , &RTType_void
	  , Bus_Cont_Protocol::Base::rti_request_position
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Bus_Cont_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Bus_Cont_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Bus_Cont_Protocol::Conjugate::rt_class =
{
	&PMission::Conjugate::rt_class
  , &Bus_Cont_Protocol::Base::rt_class
  , "Bus_Cont_Protocol"
  , 0
  , 6
  , Bus_Cont_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Bus_Cont_Protocol::Conjugate::rt_signals[] =
{
	{
		"destination_value"
	  , &RTType_int
	  , Bus_Cont_Protocol::Conjugate::rti_destination_value
	}
  , {
		"do_take_off"
	  , &RTType_void
	  , Bus_Cont_Protocol::Conjugate::rti_do_take_off
	}
  , {
		"position_value"
	  , &RTType_int
	  , Bus_Cont_Protocol::Conjugate::rti_position_value
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Bus_Cont_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Bus_Cont_Protocol::Conjugate::rti_rtUnbound
	}
  , {
		"sendMission"
	  , &RTType_MissionVant
	  , Bus_Cont_Protocol::Conjugate::rti_sendMission
	}
};

// }}}RME
