// {{{RME classifier 'Logical View::VANT::VCTRL::VPOTE::Bus_Power_Protocol'

#ifndef Bus_Power_Protocol_H
#define Bus_Power_Protocol_H

#ifdef PRAGMA
#pragma interface "Bus_Power_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>

struct Bus_Power_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_request_value_power = rtiLast_RTRootProtocol + 1
		  , rti_request_manete_status
		};

	protected:
		enum { rtiLast_Bus_Power_Protocol = rti_request_manete_status };

	public:
		inline RTInSignal request_value_power( void );
		inline RTInSignal request_manete_status( void );
		inline RTOutSignal manete_status( const int & data );
		inline RTOutSignal value_power( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_manete_status = rtiLast_RTRootProtocol + 1
		  , rti_value_power
		};

	protected:
		enum { rtiLast_Bus_Power_Protocol = rti_value_power };

	public:
		inline RTInSignal manete_status( void );
		inline RTInSignal value_power( void );
		inline RTOutSignal request_value_power( void );
		inline RTOutSignal request_manete_status( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Bus_Power_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Bus_Power_Protocol::Base::~Base( void )
{
}

inline RTInSignal Bus_Power_Protocol::Base::request_value_power( void )
{
	return RTInSignal( this, rti_request_value_power );
}

inline RTInSignal Bus_Power_Protocol::Base::request_manete_status( void )
{
	return RTInSignal( this, rti_request_manete_status );
}

inline RTOutSignal Bus_Power_Protocol::Base::manete_status( const int & data )
{
	return RTOutSignal( this, Conjugate::rti_manete_status, &data, &RTType_int );
}

inline RTOutSignal Bus_Power_Protocol::Base::value_power( const int & data )
{
	return RTOutSignal( this, Conjugate::rti_value_power, &data, &RTType_int );
}

inline Bus_Power_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Bus_Power_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Bus_Power_Protocol::Conjugate::manete_status( void )
{
	return RTInSignal( this, rti_manete_status );
}

inline RTInSignal Bus_Power_Protocol::Conjugate::value_power( void )
{
	return RTInSignal( this, rti_value_power );
}

inline RTOutSignal Bus_Power_Protocol::Conjugate::request_value_power( void )
{
	return RTOutSignal( this, Base::rti_request_value_power, (const void *)0, &RTType_void );
}

inline RTOutSignal Bus_Power_Protocol::Conjugate::request_manete_status( void )
{
	return RTOutSignal( this, Base::rti_request_manete_status, (const void *)0, &RTType_void );
}

#endif /* Bus_Power_Protocol_H */

// }}}RME
