// {{{RME classifier 'Logical View::VANT::VCTRL::VCONT::Elevator_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Elevator_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Elevator_Protocol.h>

const RTProtocolDescriptor Elevator_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Elevator_Protocol::Conjugate::rt_class
  , "Elevator_Protocol"
  , 0
  , 3
  , Elevator_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Elevator_Protocol::Base::rt_signals[] =
{
	{
		"return_elevator_status"
	  , &RTType_int
	  , Elevator_Protocol::Base::rti_return_elevator_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Elevator_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Elevator_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Elevator_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Elevator_Protocol::Base::rt_class
  , "Elevator_Protocol"
  , 0
  , 6
  , Elevator_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Elevator_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_elevator_down"
	  , &RTType_void
	  , Elevator_Protocol::Conjugate::rti_do_elevator_down
	}
  , {
		"do_elevator_up"
	  , &RTType_void
	  , Elevator_Protocol::Conjugate::rti_do_elevator_up
	}
  , {
		"do_straight"
	  , &RTType_void
	  , Elevator_Protocol::Conjugate::rti_do_straight
	}
  , {
		"request_elevator_status"
	  , &RTType_void
	  , Elevator_Protocol::Conjugate::rti_request_elevator_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Elevator_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Elevator_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
