// {{{RME classifier 'Logical View::VANT::VCNS::VVIG::Image_Classifier'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Image_Classifier.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Image_Classifier.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_controller"
	  , &Image_Classifier_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Image_Classifier_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Image_Classifier_Actor( _rts, _ref );
}

const RTActorClass Image_Classifier =
{
	(const RTActorClass *)0
  , "Image_Classifier"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_Image_Classifier_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Active"
};

#define SUPER RTActor

Image_Classifier_Actor::Image_Classifier_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Image_Classifier_Actor::~Image_Classifier_Actor( void )
{
}

int Image_Classifier_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_controller
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_controller;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Active:J4367A1A701B7:t1'
INLINE_METHODS void Image_Classifier_Actor::transition2_t1( const void * rtdata, Image_Classifier_Protocol::Conjugate * rtport )
{
	// {{{USR
	to_controller.Image_Classified().send();
	// }}}USR
}
// }}}RME

INLINE_CHAINS void Image_Classifier_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Image_Classifier_Actor::chain2_t1( void )
{
	// transition ':TOP:Active:J4367A1A701B7:t1'
	rtgChainBegin( 2, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_t1( msg->data, (Image_Classifier_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void Image_Classifier_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Active'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'to_controller'
				switch( signalIndex )
				{
				case Image_Classifier_Protocol::Conjugate::rti_Classify_Image:
					chain2_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Image_Classifier_Actor::getActorData( void ) const
{
	return &Image_Classifier_Actor::rtg_class;
}

const RTActor_class Image_Classifier_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , Image_Classifier_Actor::rtg_parent_state
  , &Image_Classifier
  , 0
  , (const RTComponentDescriptor *)0
  , 1
  , Image_Classifier_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId Image_Classifier_Actor::rtg_parent_state[] =
{
	0
  , 1
};

const RTPortDescriptor Image_Classifier_Actor::rtg_ports[] =
{
	{
		"to_controller"
	  , (const char *)0
	  , &Image_Classifier_Protocol::Conjugate::rt_class
	  , RTOffsetOf( Image_Classifier_Actor, Image_Classifier_Actor::to_controller )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
