// {{{RME classifier 'Logical View::VANT::VCNS::VVIG::Image_Controller'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Image_Controller.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Image_Controller.h>
#include <MissionVant.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_intbus"
	  , &VIG_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"to_Image_Device"
	  , &Image_Device_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"to_Image_Processor"
	  , &Image_Processor_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"to_Image_Classifier"
	  , &Image_Classifier_Protocol::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Image_Controller_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Image_Controller_Actor( _rts, _ref );
}

const RTActorClass Image_Controller =
{
	(const RTActorClass *)0
  , "Image_Controller"
  , (RTVersionId)0
  , 4
  , rtg_relays
  , new_Image_Controller_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Stoped"
  , "ProcessImage"
  , "Wating"
  , "Image_Capture"
  , "Image_Process"
  , "Image_Classify"
  , "GetImage"
  , "Atack"
  , "ImageOrAtack"
};

#define SUPER RTActor

// {{{RME classAttribute 'myMission'
MissionVant * Image_Controller_Actor::myMission;
// }}}RME

Image_Controller_Actor::Image_Controller_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
	, intMission( 1 )
{
}

Image_Controller_Actor::~Image_Controller_Actor( void )
{
}

int Image_Controller_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_intbus
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_intbus;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 1:
		// to_Image_Device
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_Image_Device;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 2:
		// to_Image_Processor
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_Image_Processor;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 3:
		// to_Image_Classifier
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_Image_Classifier;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME enter ':TOP:ProcessImage:Image_Capture'
INLINE_METHODS void Image_Controller_Actor::enter5_Image_Capture( void )
{
	// {{{USR
	to_Image_Device.take_photo().send();
	// }}}USR
}
// }}}RME

void Image_Controller_Actor::enterStateV( void )
{
	switch( getCurrentState() )
	{
	case 5:
		enter5_Image_Capture();
		break;
	case 6:
		enter6_Image_Process();
		break;
	case 7:
		enter7_Image_Classify();
		break;
	case 8:
		enter8_GetImage();
		break;
	case 9:
		enter9_Atack();
		break;
	default:
		RTActor::enterStateV();
		break;
	}
}

// {{{RME enter ':TOP:ProcessImage:Image_Process'
INLINE_METHODS void Image_Controller_Actor::enter6_Image_Process( void )
{
	// {{{USR
	to_Image_Processor.Process_Image().send();
	// }}}USR
}
// }}}RME

// {{{RME enter ':TOP:ProcessImage:Image_Classify'
INLINE_METHODS void Image_Controller_Actor::enter7_Image_Classify( void )
{
	// {{{USR
	to_Image_Classifier.Classify_Image().send();
	// }}}USR
}
// }}}RME

// {{{RME enter ':TOP:GetImage'
INLINE_METHODS void Image_Controller_Actor::enter8_GetImage( void )
{
	// {{{USR
	// atribuir o valor da imagem
	myMission->Image=2345876;

	// mensagem de acompanhamento
	printf("VCNS_VVIG: Image was catched and stored successful!!! (Image #%d)\n\n", myMission->Image);


	// final da misso
	printf("\n\n**********************************************\n");
	printf("VANT-VCNS_VVIG: MISSION #%d IS OVER! YEAH! \n",intMission);
	intMission++;
	printf("VANT-VCNS_VVIG: NOW, WAITING AGAIN...\n");
	printf("**********************************************\n\n");
	// }}}USR
}
// }}}RME

// {{{RME enter ':TOP:Atack'
INLINE_METHODS void Image_Controller_Actor::enter9_Atack( void )
{
	// {{{USR
	// mensagem de acompanhamento
	printf("\n->VCNS_VVIG: Coordinates Long#%d,Lat#%d,Alt#%d WAS ATACKED SUCCESSFUL!!!\n\n", myMission->Longitude, myMission->Latitude, myMission->Altitude);

	// final da misso
	printf("\n\n**********************************************\n");
	printf("VANT-VCNS_VVIG: MISSION #%d IS OVER! YEAH! \n",intMission);
	intMission++;
	printf("VANT-VCNS_VVIG: NOW, WAITING AGAIN...\n");
	printf("**********************************************\n\n");
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Stoped:J438738E1011A:mission'
INLINE_METHODS void Image_Controller_Actor::transition2_mission( const MissionVant * rtdata, VIG_PROTOCOL::Conjugate * rtport )
{
	// {{{USR
	myMission = ((MissionVant*) getMsg()->getData()); 


	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:ImageOrAtack:True'
INLINE_METHODS void Image_Controller_Actor::transition3_True( const MissionVant * rtdata, VIG_PROTOCOL::Conjugate * rtport )
{
	// {{{USR
	timer.informIn(RTTimespec(1,0));
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:ImageOrAtack:False'
INLINE_METHODS void Image_Controller_Actor::transition4_False( const MissionVant * rtdata, VIG_PROTOCOL::Conjugate * rtport )
{
	// {{{USR
	timer.informIn(RTTimespec(1,0));
	// }}}USR
}
// }}}RME

INLINE_CHAINS void Image_Controller_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Image_Controller_Actor::chain2_mission( void )
{
	// transition ':TOP:Stoped:J438738E1011A:mission'
	rtgChainBegin( 2, "mission" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_mission( (const MissionVant *)msg->data, (VIG_PROTOCOL::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	if( choicePoint1_ImageOrAtack( (const MissionVant *)msg->data, (VIG_PROTOCOL::Conjugate *)msg->sap() ) )
		chain3_True();
	else
		chain4_False();
}

// {{{RME choicePoint ':TOP:ImageOrAtack'
INLINE_METHODS int Image_Controller_Actor::choicePoint1_ImageOrAtack( const MissionVant * rtdata, VIG_PROTOCOL::Conjugate * rtport )
{
	// {{{USR
	return (myMission->Missao);
	// }}}USR
}
// }}}RME

INLINE_CHAINS void Image_Controller_Actor::chain3_True( void )
{
	// transition ':TOP:ImageOrAtack:True'
	rtgChainBegin( 10, "True" );
	rtgTransitionBegin();
	transition3_True( (const MissionVant *)msg->data, (VIG_PROTOCOL::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 9 );
}

INLINE_CHAINS void Image_Controller_Actor::chain4_False( void )
{
	// transition ':TOP:ImageOrAtack:False'
	rtgChainBegin( 10, "False" );
	rtgTransitionBegin();
	transition4_False( (const MissionVant *)msg->data, (VIG_PROTOCOL::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 8 );
}

INLINE_CHAINS void Image_Controller_Actor::chain8_to_Capture( void )
{
	// transition ':TOP:ProcessImage:Wating:J43679D8C0179:to_Capture'
	rtgChainBegin( 4, "to_Capture" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 5 );
}

INLINE_CHAINS void Image_Controller_Actor::chain9_to_Process( void )
{
	// transition ':TOP:ProcessImage:Image_Capture:J43679DC90157:to_Process'
	rtgChainBegin( 5, "to_Process" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 6 );
}

INLINE_CHAINS void Image_Controller_Actor::chain10_To_Classification( void )
{
	// transition ':TOP:ProcessImage:Image_Process:J43679DCC0188:To_Classification'
	rtgChainBegin( 6, "To_Classification" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 7 );
}

INLINE_CHAINS void Image_Controller_Actor::chain7_Wait( void )
{
	// transition ':TOP:ProcessImage:Image_Classify:J43679DCF00CD:Wait'
	rtgChainBegin( 7, "Wait" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void Image_Controller_Actor::chain6_timeout( void )
{
	// transition ':TOP:GetImage:J4387399700EB:timeout'
	rtgChainBegin( 8, "timeout" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Image_Controller_Actor::chain5_timeout( void )
{
	// transition ':TOP:Atack:J43873973007E:timeout'
	rtgChainBegin( 9, "timeout" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

void Image_Controller_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Stoped'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'to_intbus'
				switch( signalIndex )
				{
				case VIG_PROTOCOL::Conjugate::rti_sendMission:
					chain2_mission();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:ProcessImage'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME state ':TOP:ProcessImage:Wating'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'to_intbus'
				switch( signalIndex )
				{
				case VIG_PROTOCOL::Conjugate::rti_Captar_Imagem:
					chain8_to_Capture();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 5:
			// {{{RME state ':TOP:ProcessImage:Image_Capture'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 2:
				// {{{RME port 'to_Image_Device'
				switch( signalIndex )
				{
				case Image_Device_Protocol::Base::rti_photo_ready:
					chain9_to_Process();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 6:
			// {{{RME state ':TOP:ProcessImage:Image_Process'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 3:
				// {{{RME port 'to_Image_Processor'
				switch( signalIndex )
				{
				case Image_Processor_Protocol::Base::rti_Image_Processed:
					chain10_To_Classification();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 7:
			// {{{RME state ':TOP:ProcessImage:Image_Classify'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 4:
				// {{{RME port 'to_Image_Classifier'
				switch( signalIndex )
				{
				case Image_Classifier_Protocol::Base::rti_Image_Classified:
					chain7_Wait();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 8:
			// {{{RME state ':TOP:GetImage'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain6_timeout();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 9:
			// {{{RME state ':TOP:Atack'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain5_timeout();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Image_Controller_Actor::getActorData( void ) const
{
	return &Image_Controller_Actor::rtg_class;
}

const RTActor_class Image_Controller_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 9
  , Image_Controller_Actor::rtg_parent_state
  , &Image_Controller
  , 0
  , (const RTComponentDescriptor *)0
  , 5
  , Image_Controller_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 1
  , Image_Controller_Actor::rtg_Image_Controller_fields
};

const RTStateId Image_Controller_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 3
  , 3
  , 3
  , 3
  , 1
  , 1
};

const RTPortDescriptor Image_Controller_Actor::rtg_ports[] =
{
	{
		"to_intbus"
	  , (const char *)0
	  , &VIG_PROTOCOL::Conjugate::rt_class
	  , RTOffsetOf( Image_Controller_Actor, Image_Controller_Actor::to_intbus )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"to_Image_Device"
	  , (const char *)0
	  , &Image_Device_Protocol::Base::rt_class
	  , RTOffsetOf( Image_Controller_Actor, Image_Controller_Actor::to_Image_Device )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"to_Image_Processor"
	  , (const char *)0
	  , &Image_Processor_Protocol::Base::rt_class
	  , RTOffsetOf( Image_Controller_Actor, Image_Controller_Actor::to_Image_Processor )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"to_Image_Classifier"
	  , (const char *)0
	  , &Image_Classifier_Protocol::Base::rt_class
	  , RTOffsetOf( Image_Controller_Actor, Image_Controller_Actor::to_Image_Classifier )
	  , 1 // cardinality
	  , 4
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( Image_Controller_Actor, Image_Controller_Actor::timer )
	  , 1 // cardinality
	  , 5
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
};

const RTFieldDescriptor Image_Controller_Actor::rtg_Image_Controller_fields[] =
{
	// {{{RME classAttribute 'intMission'
	{
		"intMission"
	  , RTOffsetOf( Image_Controller_Actor, intMission )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_int
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
