// {{{RME classifier 'Logical View::VANT::VCNS::VVIG::Image_Controller'

#ifndef Image_Controller_H
#define Image_Controller_H

#ifdef PRAGMA
#pragma interface "Image_Controller.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Image_Classifier_Protocol.h>
#include <Image_Device_Protocol.h>
#include <Image_Processor_Protocol.h>
#include <VIG_PROTOCOL.h>
class MissionVant;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include <stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass Image_Controller;

#define SUPER RTActor
class Image_Controller_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'myMission'
	static MissionVant * myMission;
	// }}}RME
	// {{{RME classAttribute 'intMission'
	int intMission;
	// }}}RME

protected:
	// {{{RME port 'to_intbus'
	VIG_PROTOCOL::Conjugate to_intbus;
	// }}}RME
	// {{{RME port 'to_Image_Device'
	Image_Device_Protocol::Base to_Image_Device;
	// }}}RME
	// {{{RME port 'to_Image_Processor'
	Image_Processor_Protocol::Base to_Image_Processor;
	// }}}RME
	// {{{RME port 'to_Image_Classifier'
	Image_Classifier_Protocol::Base to_Image_Classifier;
	// }}}RME
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME

public:
	Image_Controller_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Image_Controller_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME enter ':TOP:ProcessImage:Image_Capture'
	INLINE_METHODS void enter5_Image_Capture( void );
	// }}}RME
	virtual void enterStateV( void );
	// {{{RME enter ':TOP:ProcessImage:Image_Process'
	INLINE_METHODS void enter6_Image_Process( void );
	// }}}RME
	// {{{RME enter ':TOP:ProcessImage:Image_Classify'
	INLINE_METHODS void enter7_Image_Classify( void );
	// }}}RME
	// {{{RME enter ':TOP:GetImage'
	INLINE_METHODS void enter8_GetImage( void );
	// }}}RME
	// {{{RME enter ':TOP:Atack'
	INLINE_METHODS void enter9_Atack( void );
	// }}}RME
	// {{{RME transition ':TOP:Stoped:J438738E1011A:mission'
	INLINE_METHODS void transition2_mission( const MissionVant * rtdata, VIG_PROTOCOL::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:ImageOrAtack:True'
	INLINE_METHODS void transition3_True( const MissionVant * rtdata, VIG_PROTOCOL::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:ImageOrAtack:False'
	INLINE_METHODS void transition4_False( const MissionVant * rtdata, VIG_PROTOCOL::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_mission( void );

protected:
	// {{{RME choicePoint ':TOP:ImageOrAtack'
	INLINE_METHODS int choicePoint1_ImageOrAtack( const MissionVant * rtdata, VIG_PROTOCOL::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain3_True( void );
	INLINE_CHAINS void chain4_False( void );
	INLINE_CHAINS void chain8_to_Capture( void );
	INLINE_CHAINS void chain9_to_Process( void );
	INLINE_CHAINS void chain10_To_Classification( void );
	INLINE_CHAINS void chain7_Wait( void );
	INLINE_CHAINS void chain6_timeout( void );
	INLINE_CHAINS void chain5_timeout( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_Image_Controller_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Image_Controller_H */

// }}}RME
