// {{{RME classifier 'Logical View::VANT::VCNS::VVIG::Image_Device_Protocol'

#ifndef Image_Device_Protocol_H
#define Image_Device_Protocol_H

#ifdef PRAGMA
#pragma interface "Image_Device_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>

struct Image_Device_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_photo_ready = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Image_Device_Protocol = rti_photo_ready };

	public:
		inline RTInSignal photo_ready( void );
		inline RTOutSignal take_photo( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_take_photo = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Image_Device_Protocol = rti_take_photo };

	public:
		inline RTInSignal take_photo( void );
		inline RTOutSignal photo_ready( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Image_Device_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Image_Device_Protocol::Base::~Base( void )
{
}

inline RTInSignal Image_Device_Protocol::Base::photo_ready( void )
{
	return RTInSignal( this, rti_photo_ready );
}

inline RTOutSignal Image_Device_Protocol::Base::take_photo( void )
{
	return RTOutSignal( this, Conjugate::rti_take_photo, (const void *)0, &RTType_void );
}

inline Image_Device_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Image_Device_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Image_Device_Protocol::Conjugate::take_photo( void )
{
	return RTInSignal( this, rti_take_photo );
}

inline RTOutSignal Image_Device_Protocol::Conjugate::photo_ready( void )
{
	return RTOutSignal( this, Base::rti_photo_ready, (const void *)0, &RTType_void );
}

#endif /* Image_Device_Protocol_H */

// }}}RME
