// {{{RME classifier 'Logical View::VANT::VCNS::VVIG::Image_Processor'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Image_Processor.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Image_Processor.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_controller"
	  , &Image_Processor_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Image_Processor_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Image_Processor_Actor( _rts, _ref );
}

const RTActorClass Image_Processor =
{
	(const RTActorClass *)0
  , "Image_Processor"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_Image_Processor_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Active"
};

#define SUPER RTActor

Image_Processor_Actor::Image_Processor_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Image_Processor_Actor::~Image_Processor_Actor( void )
{
}

int Image_Processor_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_controller
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_controller;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Active:J4367A15D010B:process_image'
INLINE_METHODS void Image_Processor_Actor::transition2_process_image( const void * rtdata, Image_Processor_Protocol::Conjugate * rtport )
{
	// {{{USR
	to_controller.Image_Processed().send();
	// }}}USR
}
// }}}RME

INLINE_CHAINS void Image_Processor_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Image_Processor_Actor::chain2_process_image( void )
{
	// transition ':TOP:Active:J4367A15D010B:process_image'
	rtgChainBegin( 2, "process_image" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_process_image( msg->data, (Image_Processor_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void Image_Processor_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Active'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'to_controller'
				switch( signalIndex )
				{
				case Image_Processor_Protocol::Conjugate::rti_Process_Image:
					chain2_process_image();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Image_Processor_Actor::getActorData( void ) const
{
	return &Image_Processor_Actor::rtg_class;
}

const RTActor_class Image_Processor_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , Image_Processor_Actor::rtg_parent_state
  , &Image_Processor
  , 0
  , (const RTComponentDescriptor *)0
  , 1
  , Image_Processor_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId Image_Processor_Actor::rtg_parent_state[] =
{
	0
  , 1
};

const RTPortDescriptor Image_Processor_Actor::rtg_ports[] =
{
	{
		"to_controller"
	  , (const char *)0
	  , &Image_Processor_Protocol::Conjugate::rt_class
	  , RTOffsetOf( Image_Processor_Actor, Image_Processor_Actor::to_controller )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
