// {{{RME classifier 'Logical View::VANT::VCNS::VVIG::Image_Processor_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Image_Processor_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Image_Processor_Protocol.h>

const RTProtocolDescriptor Image_Processor_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Image_Processor_Protocol::Conjugate::rt_class
  , "Image_Processor_Protocol"
  , 0
  , 3
  , Image_Processor_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Image_Processor_Protocol::Base::rt_signals[] =
{
	{
		"Image_Processed"
	  , &RTType_void
	  , Image_Processor_Protocol::Base::rti_Image_Processed
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Image_Processor_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Image_Processor_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Image_Processor_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Image_Processor_Protocol::Base::rt_class
  , "Image_Processor_Protocol"
  , 0
  , 3
  , Image_Processor_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Image_Processor_Protocol::Conjugate::rt_signals[] =
{
	{
		"Process_Image"
	  , &RTType_void
	  , Image_Processor_Protocol::Conjugate::rti_Process_Image
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Image_Processor_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Image_Processor_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
