// {{{RME classifier 'Logical View::VANT::VCTRL::VCOMB::Level_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Level_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Level_Protocol.h>

const RTProtocolDescriptor Level_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Level_Protocol::Conjugate::rt_class
  , "Level_Protocol"
  , 0
  , 3
  , Level_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Level_Protocol::Base::rt_signals[] =
{
	{
		"level_value"
	  , &RTType_int
	  , Level_Protocol::Base::rti_level_value
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Level_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Level_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Level_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Level_Protocol::Base::rt_class
  , "Level_Protocol"
  , 0
  , 7
  , Level_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Level_Protocol::Conjugate::rt_signals[] =
{
	{
		"engine_off"
	  , &RTType_void
	  , Level_Protocol::Conjugate::rti_engine_off
	}
  , {
		"engine_on"
	  , &RTType_void
	  , Level_Protocol::Conjugate::rti_engine_on
	}
  , {
		"level_factor"
	  , &RTType_int
	  , Level_Protocol::Conjugate::rti_level_factor
	}
  , {
		"request_fuel_level"
	  , &RTType_void
	  , Level_Protocol::Conjugate::rti_request_fuel_level
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Level_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Level_Protocol::Conjugate::rti_rtUnbound
	}
  , {
		"unload"
	  , &RTType_void
	  , Level_Protocol::Conjugate::rti_unload
	}
};

// }}}RME
