// {{{RME classifier 'Logical View::VANT::VCTRL::VCOMB::Mix'

#ifndef Mix_H
#define Mix_H

#ifdef PRAGMA
#pragma interface "Mix.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Mix_Protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Mix;

#define SUPER RTActor
class Mix_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'mix_status'
	bool mix_status;
	// }}}RME

protected:
	// {{{RME port 'to_controller'
	Mix_Protocol::Conjugate to_controller;
	// }}}RME

public:
	Mix_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Mix_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Active:J4359970C01E6:request_mix'
	INLINE_METHODS void transition2_request_mix( const void * rtdata, Mix_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J435997BF02F0:active_mix'
	INLINE_METHODS void transition3_active_mix( const void * rtdata, Mix_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J435997ED0188:deactive_mix'
	INLINE_METHODS void transition4_deactive_mix( const void * rtdata, Mix_Protocol::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_request_mix( void );
	INLINE_CHAINS void chain3_active_mix( void );
	INLINE_CHAINS void chain4_deactive_mix( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_Mix_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Mix_H */

// }}}RME
