// {{{RME classifier 'Logical View::VANT::VCNS::VNAV::NAV_Controller'

#ifndef NAV_Controller_H
#define NAV_Controller_H

#ifdef PRAGMA
#pragma interface "NAV_Controller.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <NAV_PROTOCOL.h>
#include <Navigation_Plan_Protocol.h>
class MissionVant;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass NAV_Controller;

#define SUPER RTActor
class NAV_Controller_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME port 'to_bus'
	NAV_PROTOCOL::Conjugate to_bus;
	// }}}RME
	// {{{RME port 'from_controller'
	Navigation_Plan_Protocol::Base from_controller;
	// }}}RME

public:
	NAV_Controller_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~NAV_Controller_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Waiting:J436F5D1501B7:traj_data'
	INLINE_METHODS void transition2_traj_data( const int * rtdata, NAV_PROTOCOL::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Trajectory_Plan:J436F5D23006E:traj_planned'
	INLINE_METHODS void transition3_traj_planned( const int * rtdata, Navigation_Plan_Protocol::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_traj_data( void );
	INLINE_CHAINS void chain3_traj_planned( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* NAV_Controller_H */

// }}}RME
