// {{{RME classifier 'Logical View::VANT::VCNS::VNAV::Navigation_Plan_Protocol'

#ifndef Navigation_Plan_Protocol_H
#define Navigation_Plan_Protocol_H

#ifdef PRAGMA
#pragma interface "Navigation_Plan_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>

struct Navigation_Plan_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_traj_planned = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Navigation_Plan_Protocol = rti_traj_planned };

	public:
		inline RTInSignal traj_planned( void );
		inline RTOutSignal request_traj_plan( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_request_traj_plan = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Navigation_Plan_Protocol = rti_request_traj_plan };

	public:
		inline RTInSignal request_traj_plan( void );
		inline RTOutSignal traj_planned( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Navigation_Plan_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Navigation_Plan_Protocol::Base::~Base( void )
{
}

inline RTInSignal Navigation_Plan_Protocol::Base::traj_planned( void )
{
	return RTInSignal( this, rti_traj_planned );
}

inline RTOutSignal Navigation_Plan_Protocol::Base::request_traj_plan( const int & data )
{
	return RTOutSignal( this, Conjugate::rti_request_traj_plan, &data, &RTType_int );
}

inline Navigation_Plan_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Navigation_Plan_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Navigation_Plan_Protocol::Conjugate::request_traj_plan( void )
{
	return RTInSignal( this, rti_request_traj_plan );
}

inline RTOutSignal Navigation_Plan_Protocol::Conjugate::traj_planned( const int & data )
{
	return RTOutSignal( this, Base::rti_traj_planned, &data, &RTType_int );
}

#endif /* Navigation_Plan_Protocol_H */

// }}}RME
