// {{{RME classifier 'Logical View::VANT::VCTRL::VCONT::Power_Cont_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Power_Cont_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Power_Cont_Protocol.h>

const RTProtocolDescriptor Power_Cont_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Power_Cont_Protocol::Conjugate::rt_class
  , "Power_Cont_Protocol"
  , 0
  , 8
  , Power_Cont_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Power_Cont_Protocol::Base::rt_signals[] =
{
	{
		"decrease_power"
	  , &RTType_void
	  , Power_Cont_Protocol::Base::rti_decrease_power
	}
  , {
		"do_engine_off"
	  , &RTType_void
	  , Power_Cont_Protocol::Base::rti_do_engine_off
	}
  , {
		"do_engine_on"
	  , &RTType_void
	  , Power_Cont_Protocol::Base::rti_do_engine_on
	}
  , {
		"increase_power"
	  , &RTType_void
	  , Power_Cont_Protocol::Base::rti_increase_power
	}
  , {
		"request_full_power"
	  , &RTType_void
	  , Power_Cont_Protocol::Base::rti_request_full_power
	}
  , {
		"request_low_power"
	  , &RTType_void
	  , Power_Cont_Protocol::Base::rti_request_low_power
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Power_Cont_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Power_Cont_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Power_Cont_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Power_Cont_Protocol::Base::rt_class
  , "Power_Cont_Protocol"
  , 0
  , 6
  , Power_Cont_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Power_Cont_Protocol::Conjugate::rt_signals[] =
{
	{
		"engine_off"
	  , &RTType_void
	  , Power_Cont_Protocol::Conjugate::rti_engine_off
	}
  , {
		"engine_on"
	  , &RTType_void
	  , Power_Cont_Protocol::Conjugate::rti_engine_on
	}
  , {
		"full_power"
	  , &RTType_void
	  , Power_Cont_Protocol::Conjugate::rti_full_power
	}
  , {
		"low_power"
	  , &RTType_void
	  , Power_Cont_Protocol::Conjugate::rti_low_power
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Power_Cont_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Power_Cont_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
