// {{{RME classifier 'Logical View::VANT::VSUP::VCXP::RegistrarParametro'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "RegistrarParametro.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <RegistrarParametro.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"roll"
	  , &vcxp_protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"angle"
	  , &vcxp_protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"heading"
	  , &vcxp_protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"outUSC"
	  , &vcxp_protocol::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_RegistrarParametro_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new RegistrarParametro_Actor( _rts, _ref );
}

const RTActorClass RegistrarParametro =
{
	(const RTActorClass *)0
  , "RegistrarParametro"
  , (RTVersionId)0
  , 4
  , rtg_relays
  , new_RegistrarParametro_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Espera"
  , "CapturarParametro"
  , "ValidarParametro"
  , "EmpacotarParametro"
  , "RegistrarParametro"
  , "IsValid"
};

#define SUPER RTActor

RegistrarParametro_Actor::RegistrarParametro_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
	, status( 0 )
	, vlrParametro( 20 )
{
}

RegistrarParametro_Actor::~RegistrarParametro_Actor( void )
{
}

// {{{RME operation 'Validar()'
void RegistrarParametro_Actor::Validar( void )
{
	// {{{USR
	printf("entrou no metodo ValidarParametro\n\n\n");
	status = false;

	// }}}USR
}
// }}}RME

// {{{RME operation 'Empacotar()'
void RegistrarParametro_Actor::Empacotar( void )
{
	// {{{USR
	printf("entrou no metodo Empacotar...\n\n");
	// }}}USR
}
// }}}RME

// {{{RME operation 'Registrar()'
void RegistrarParametro_Actor::Registrar( void )
{
	// {{{USR
	printf("entrou no metodo Registrar\n\n\n");
	// }}}USR
}
// }}}RME

int RegistrarParametro_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// roll
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &roll;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 1:
		// angle
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &angle;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 2:
		// heading
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &heading;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 3:
		// outUSC
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &outUSC;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Initial:Initial'
INLINE_METHODS void RegistrarParametro_Actor::transition1_Initial( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	printf("\n\n\n*** BLACK BOX ACTIVATED *** \n\n");
	printf("MSG_VCXP: Now listening... \n");
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Espera:J4354E79E003F:t1'
INLINE_METHODS void RegistrarParametro_Actor::transition2_t1( const int * rtdata, vcxp_protocol::Base * rtport )
{
	// {{{USR
	printf("MSG_VCXP: Get data - Data received...\n");
	timer.informIn(RTTimespec(1,0));

	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:RegistrarParametro:J4354E8100178:t1'
INLINE_METHODS void RegistrarParametro_Actor::transition3_t1( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	printf("MSG_VCXP: Writing parameter... \n");

	Registrar();
	//timer.informIn(RTTimespec(1,0));

	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:EmpacotarParametro:J4354E813036C:t1'
INLINE_METHODS void RegistrarParametro_Actor::transition4_t1( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	printf("MSG_VCXP: Packaging parameter... \n");

	Empacotar();
	timer.informIn(RTTimespec(1,0));
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:CapturarParametro:J4354E81A001F:t1'
INLINE_METHODS void RegistrarParametro_Actor::transition5_t1( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	printf("MSG_VCXP: Validating parameter...\n");
	Validar();
	timer.informIn(RTTimespec(1,0));


	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:ValidarParametro:J4356351C0252:t1'
INLINE_METHODS void RegistrarParametro_Actor::transition6_t1( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	printf("MSG_VCXP: Verifing status parameter...\n");
	timer.informIn(RTTimespec(1,0));
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:IsValid:True'
INLINE_METHODS void RegistrarParametro_Actor::transition7_True( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	printf("MSG_VCXP: Parameter OK... \n");


	timer.informIn(RTTimespec(1,0));
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:IsValid:False'
INLINE_METHODS void RegistrarParametro_Actor::transition8_False( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	printf("MSG_VCXP: Parameter with error... \n");


	// }}}USR
}
// }}}RME

INLINE_CHAINS void RegistrarParametro_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	transition1_Initial( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RegistrarParametro_Actor::chain2_t1( void )
{
	// transition ':TOP:Espera:J4354E79E003F:t1'
	rtgChainBegin( 2, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_t1( (const int *)msg->data, (vcxp_protocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void RegistrarParametro_Actor::chain5_t1( void )
{
	// transition ':TOP:CapturarParametro:J4354E81A001F:t1'
	rtgChainBegin( 3, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition5_t1( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void RegistrarParametro_Actor::chain6_t1( void )
{
	// transition ':TOP:ValidarParametro:J4356351C0252:t1'
	rtgChainBegin( 4, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition6_t1( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	if( choicePoint1_IsValid( msg->data, (Timing::Base *)msg->sap() ) )
		chain7_True();
	else
		chain8_False();
}

// {{{RME choicePoint ':TOP:IsValid'
INLINE_METHODS int RegistrarParametro_Actor::choicePoint1_IsValid( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	return (status);
	// }}}USR
}
// }}}RME

INLINE_CHAINS void RegistrarParametro_Actor::chain7_True( void )
{
	// transition ':TOP:IsValid:True'
	rtgChainBegin( 7, "True" );
	rtgTransitionBegin();
	transition7_True( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 5 );
}

INLINE_CHAINS void RegistrarParametro_Actor::chain8_False( void )
{
	// transition ':TOP:IsValid:False'
	rtgChainBegin( 7, "False" );
	rtgTransitionBegin();
	transition8_False( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RegistrarParametro_Actor::chain4_t1( void )
{
	// transition ':TOP:EmpacotarParametro:J4354E813036C:t1'
	rtgChainBegin( 5, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition4_t1( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 6 );
}

INLINE_CHAINS void RegistrarParametro_Actor::chain3_t1( void )
{
	// transition ':TOP:RegistrarParametro:J4354E8100178:t1'
	rtgChainBegin( 6, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition3_t1( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void RegistrarParametro_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Espera'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'outUSC'
				switch( signalIndex )
				{
				case vcxp_protocol::Base::rti_Angle:
					chain2_t1();
					return;
				case vcxp_protocol::Base::rti_Heading:
					chain2_t1();
					return;
				case vcxp_protocol::Base::rti_Roll:
					chain2_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:CapturarParametro'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain5_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME state ':TOP:ValidarParametro'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain6_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 5:
			// {{{RME state ':TOP:EmpacotarParametro'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain4_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 6:
			// {{{RME state ':TOP:RegistrarParametro'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain3_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * RegistrarParametro_Actor::getActorData( void ) const
{
	return &RegistrarParametro_Actor::rtg_class;
}

const RTActor_class RegistrarParametro_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 6
  , RegistrarParametro_Actor::rtg_parent_state
  , &RegistrarParametro
  , 0
  , (const RTComponentDescriptor *)0
  , 5
  , RegistrarParametro_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 3
  , RegistrarParametro_Actor::rtg_RegistrarParametro_fields
};

const RTStateId RegistrarParametro_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 1
  , 1
  , 1
};

const RTPortDescriptor RegistrarParametro_Actor::rtg_ports[] =
{
	{
		"timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( RegistrarParametro_Actor, RegistrarParametro_Actor::timer )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"roll"
	  , (const char *)0
	  , &vcxp_protocol::Base::rt_class
	  , RTOffsetOf( RegistrarParametro_Actor, RegistrarParametro_Actor::roll )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"angle"
	  , (const char *)0
	  , &vcxp_protocol::Base::rt_class
	  , RTOffsetOf( RegistrarParametro_Actor, RegistrarParametro_Actor::angle )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"heading"
	  , (const char *)0
	  , &vcxp_protocol::Base::rt_class
	  , RTOffsetOf( RegistrarParametro_Actor, RegistrarParametro_Actor::heading )
	  , 1 // cardinality
	  , 4
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"outUSC"
	  , (const char *)0
	  , &vcxp_protocol::Base::rt_class
	  , RTOffsetOf( RegistrarParametro_Actor, RegistrarParametro_Actor::outUSC )
	  , 1 // cardinality
	  , 5
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

const RTFieldDescriptor RegistrarParametro_Actor::rtg_RegistrarParametro_fields[] =
{
	// {{{RME classAttribute 'status'
	{
		"status"
	  , RTOffsetOf( RegistrarParametro_Actor, status )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_bool
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
	// {{{RME classAttribute 'vlrParametro'
  , {
		"vlrParametro"
	  , RTOffsetOf( RegistrarParametro_Actor, vlrParametro )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_char
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
	// {{{RME classAttribute 'hora'
  , {
		"hora"
	  , RTOffsetOf( RegistrarParametro_Actor, hora )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_int
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
