// {{{RME classifier 'Logical View::VANT::VCTRL::VCONT::Rudder_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Rudder_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Rudder_Protocol.h>

const RTProtocolDescriptor Rudder_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Rudder_Protocol::Conjugate::rt_class
  , "Rudder_Protocol"
  , 0
  , 3
  , Rudder_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Rudder_Protocol::Base::rt_signals[] =
{
	{
		"rtBound"
	  , (const RTObject_class *)0
	  , Rudder_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Rudder_Protocol::Base::rti_rtUnbound
	}
  , {
		"rudder_status"
	  , &RTType_int
	  , Rudder_Protocol::Base::rti_rudder_status
	}
};

const RTProtocolDescriptor Rudder_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Rudder_Protocol::Base::rt_class
  , "Rudder_Protocol"
  , 0
  , 6
  , Rudder_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Rudder_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_rudder_left"
	  , &RTType_void
	  , Rudder_Protocol::Conjugate::rti_do_rudder_left
	}
  , {
		"do_rudder_right"
	  , &RTType_void
	  , Rudder_Protocol::Conjugate::rti_do_rudder_right
	}
  , {
		"do_rudder_straight"
	  , &RTType_void
	  , Rudder_Protocol::Conjugate::rti_do_rudder_straight
	}
  , {
		"request_rudder_status"
	  , &RTType_void
	  , Rudder_Protocol::Conjugate::rti_request_rudder_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Rudder_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Rudder_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
