// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::Status_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Status_Protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Status_Protocol.h>

const RTProtocolDescriptor Status_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Status_Protocol::Conjugate::rt_class
  , "Status_Protocol"
  , 0
  , 5
  , Status_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Status_Protocol::Base::rt_signals[] =
{
	{
		"request"
	  , &RTType_void
	  , Status_Protocol::Base::rti_request
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Status_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Status_Protocol::Base::rti_rtUnbound
	}
  , {
		"turnBusy"
	  , &RTType_bool
	  , Status_Protocol::Base::rti_turnBusy
	}
  , {
		"turnIdle"
	  , &RTType_bool
	  , Status_Protocol::Base::rti_turnIdle
	}
};

const RTProtocolDescriptor Status_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Status_Protocol::Base::rt_class
  , "Status_Protocol"
  , 0
  , 3
  , Status_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Status_Protocol::Conjugate::rt_signals[] =
{
	{
		"rtBound"
	  , (const RTObject_class *)0
	  , Status_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Status_Protocol::Conjugate::rti_rtUnbound
	}
  , {
		"status"
	  , &RTType_bool
	  , Status_Protocol::Conjugate::rti_status
	}
};

// }}}RME
