// {{{RME classifier 'Logical View::VANT_EC_SAT'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VANT_EC_SAT.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <VANT_EC_SAT.h>
#include <COM_PROTOCOL.h>
extern const RTActorClass VANT_Main;
extern const RTActorClass stubEC;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static RTActor * new_VANT_EC_SAT_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VANT_EC_SAT_Actor( _rts, _ref );
}

const RTActorClass VANT_EC_SAT =
{
	(const RTActorClass *)0
  , "VANT_EC_SAT"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_VANT_EC_SAT_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vant[] =
{
	{
		"OutEC"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vant[] =
{
	{
		0
	  , &COM_PROTOCOL::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_stubec[] =
{
	{
		"ec"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_stubec[] =
{
	{
		0
	  , &COM_PROTOCOL::Conjugate::rt_class
	}
};

#define SUPER RTActor

VANT_EC_SAT_Actor::VANT_EC_SAT_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VANT_EC_SAT_Actor::~VANT_EC_SAT_Actor( void )
{
}

int VANT_EC_SAT_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vant
		switch( rtg_portId )
		{
		case 0:
			// OutEC
			if( rtg_repIndex < 1 )
			{
				// stubec/ec
				return stubec._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// stubec
		switch( rtg_portId )
		{
		case 0:
			// ec
			if( rtg_repIndex < 1 )
			{
				// vant/OutEC
				return vant._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VANT_EC_SAT_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VANT_EC_SAT_Actor::getActorData( void ) const
{
	return &VANT_EC_SAT_Actor::rtg_class;
}

const RTActor_class VANT_EC_SAT_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VANT_EC_SAT_Actor::rtg_parent_state
  , &VANT_EC_SAT
  , 2
  , VANT_EC_SAT_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VANT_EC_SAT_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VANT_EC_SAT_Actor::rtg_capsule_roles[] =
{
	{
		"vant"
	  , &VANT_Main
	  , RTOffsetOf( VANT_EC_SAT_Actor, vant )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vant
	  , 1
	  , rtg_bindings_vant
	}
  , {
		"stubec"
	  , &stubEC
	  , RTOffsetOf( VANT_EC_SAT_Actor, stubec )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_stubec
	  , 1
	  , rtg_bindings_stubec
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
