// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::VBAD_Interface'

#ifndef VBAD_Interface_H
#define VBAD_Interface_H

#ifdef PRAGMA
#pragma interface "VBAD_Interface.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <Bus_Comb_Protocol.h>
#include <Bus_Cont_Protocol.h>
#include <Bus_Power_Protocol.h>
#include <COM_PROTOCOL.h>
#include <NAV_PROTOCOL.h>
#include <VBAD_PInterface.h>
#include <VIG_PROTOCOL.h>
#include <vcal_protocol.h>
#include <vcxp_protocol.h>
#include <vsel_protocol.h>
class MissionVant;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include <stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass VBAD_Interface;

#define SUPER RTActor
class VBAD_Interface_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME port 'interface_mi'
	VBAD_PInterface::Base interface_mi;
	// }}}RME
	// {{{RME port 'interface_status'
	VBAD_PInterface::Conjugate interface_status;
	// }}}RME
	// {{{RME port 'interface_rw'
	VBAD_PInterface::Base interface_rw;
	// }}}RME
	// {{{RME port 'vbad_vcal'
	vcal_protocol::Conjugate vbad_vcal;
	// }}}RME
	// {{{RME port 'vbad_vcxp'
	vcxp_protocol::Conjugate vbad_vcxp;
	// }}}RME
	// {{{RME port 'vbad_vsel'
	vsel_protocol::Conjugate vbad_vsel;
	// }}}RME
	// {{{RME port 'bus_power_control'
	Bus_Power_Protocol::Conjugate bus_power_control;
	// }}}RME
	// {{{RME port 'bus_cont_sup'
	Bus_Cont_Protocol::Base bus_cont_sup;
	// }}}RME
	// {{{RME port 'bus_comb_sup'
	Bus_Comb_Protocol::Base bus_comb_sup;
	// }}}RME
	// {{{RME port 'nav_sup'
	NAV_PROTOCOL::Base nav_sup;
	// }}}RME
	// {{{RME port 'vig_sup'
	VIG_PROTOCOL::Base vig_sup;
	// }}}RME
	// {{{RME port 'com_sup'
	COM_PROTOCOL::Conjugate com_sup;
	// }}}RME

public:
	VBAD_Interface_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~VBAD_Interface_Actor( void );

protected:
	// {{{RME operation 'Kernel()'
	void Kernel( void );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:InternalEntrance:J434BCABD0178:t_monitora_interrupt'
	INLINE_METHODS void transition2_t_monitora_interrupt( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:MI:J434E9C490242:t_return_minterrupt'
	INLINE_METHODS void transition3_t_return_minterrupt( const void * rtdata, VBAD_PInterface::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:InternalEntrance:J434FCC03039A:t_monitora_status'
	INLINE_METHODS void transition4_t_monitora_status( const void * rtdata, VBAD_PInterface::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:STA:J434FCCCD0204:t_return_status'
	INLINE_METHODS void transition5_t_return_status( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:InternalEntrance:J434FCD3A03AA:t_monitora_r'
	INLINE_METHODS void transition6_t_monitora_r( const char * rtdata, vbad_inheritance::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:RW:J434FCDDF002E:t_return_rw'
	INLINE_METHODS void transition7_t_return_rw( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:InternalEntrance:J434FD5B1039A:t_monitora_w'
	INLINE_METHODS void transition8_t_monitora_w( const void * rtdata, RTProtocol * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain4_t_monitora_status( void );
	INLINE_CHAINS void chain6_t_monitora_r( void );
	INLINE_CHAINS void chain8_t_monitora_w( void );
	INLINE_CHAINS void chain3_t_return_minterrupt( void );
	INLINE_CHAINS void chain7_t_return_rw( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* VBAD_Interface_H */

// }}}RME
