// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::VBAD_MI'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VBAD_MI.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <VBAD_MI.h>
#include <VBAD_RW.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"mi_port"
	  , &VBAD_PInterface::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VBAD_MI_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VBAD_MI_Actor( _rts, _ref );
}

const RTActorClass VBAD_MI =
{
	(const RTActorClass *)0
  , "VBAD_MI"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_VBAD_MI_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Waiting"
  , "ExecuteTask"
  , "verify_priorit_high"
};

#define SUPER RTActor

VBAD_MI_Actor::VBAD_MI_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VBAD_MI_Actor::~VBAD_MI_Actor( void )
{
}

// {{{RME operation 'InterruptMonitor()'
bool VBAD_MI_Actor::InterruptMonitor( void )
{
	// {{{USR
	return true;
	// }}}USR
}
// }}}RME

int VBAD_MI_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// mi_port
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &mi_port;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Waiting:J434E99B7034C:t_verify_priority'
INLINE_METHODS void VBAD_MI_Actor::transition2_t_verify_priority( const void * rtdata, VBAD_PInterface::Conjugate * rtport )
{
	// {{{USR
	printf("\n\nMSG_MI: Interrupting Monitor active...\n");
	printf("MSG_MI: Verify task...\n");
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:verify_priorit_high:True'
INLINE_METHODS void VBAD_MI_Actor::transition3_True( const void * rtdata, VBAD_PInterface::Conjugate * rtport )
{
	// {{{USR
	printf("MSG_MI: Executing new task...\n");
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:verify_priorit_high:False'
INLINE_METHODS void VBAD_MI_Actor::transition4_False( const void * rtdata, VBAD_PInterface::Conjugate * rtport )
{
	// {{{USR
	// msg informando acao
	printf("MSG_MI: Task has not priority to be executed at moment...\n");

	// sinal informando que jah foi feita interrupcao
	mi_port.returnContext().send();
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:ExecuteTask:J434E9B1F02CF:t_return'
INLINE_METHODS void VBAD_MI_Actor::transition5_t_return( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	// msg informando a execucao feita
	printf("MSG_MI: Task were executed with sucessful!\n");

	// sinal informando que jah foi feita interrupcao
	mi_port.returnContext().send();
	// }}}USR
}
// }}}RME

INLINE_CHAINS void VBAD_MI_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void VBAD_MI_Actor::chain2_t_verify_priority( void )
{
	// transition ':TOP:Waiting:J434E99B7034C:t_verify_priority'
	rtgChainBegin( 2, "t_verify_priority" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_t_verify_priority( msg->data, (VBAD_PInterface::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	if( choicePoint1_verify_priorit_high( msg->data, (VBAD_PInterface::Conjugate *)msg->sap() ) )
		chain3_True();
	else
		chain4_False();
}

// {{{RME choicePoint ':TOP:verify_priorit_high'
INLINE_METHODS int VBAD_MI_Actor::choicePoint1_verify_priorit_high( const void * rtdata, VBAD_PInterface::Conjugate * rtport )
{
	// {{{USR
	return (false);
	// }}}USR
}
// }}}RME

INLINE_CHAINS void VBAD_MI_Actor::chain3_True( void )
{
	// transition ':TOP:verify_priorit_high:True'
	rtgChainBegin( 4, "True" );
	rtgTransitionBegin();
	transition3_True( msg->data, (VBAD_PInterface::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void VBAD_MI_Actor::chain4_False( void )
{
	// transition ':TOP:verify_priorit_high:False'
	rtgChainBegin( 4, "False" );
	rtgTransitionBegin();
	transition4_False( msg->data, (VBAD_PInterface::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void VBAD_MI_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Waiting'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'mi_port'
				switch( signalIndex )
				{
				case VBAD_PInterface::Conjugate::rti_activeMI:
					chain2_t_verify_priority();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:ExecuteTask'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VBAD_MI_Actor::getActorData( void ) const
{
	return &VBAD_MI_Actor::rtg_class;
}

const RTActor_class VBAD_MI_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 3
  , VBAD_MI_Actor::rtg_parent_state
  , &VBAD_MI
  , 0
  , (const RTComponentDescriptor *)0
  , 1
  , VBAD_MI_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 2
  , VBAD_MI_Actor::rtg_VBAD_MI_fields
};

const RTStateId VBAD_MI_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
};

const RTPortDescriptor VBAD_MI_Actor::rtg_ports[] =
{
	{
		"mi_port"
	  , (const char *)0
	  , &VBAD_PInterface::Conjugate::rt_class
	  , RTOffsetOf( VBAD_MI_Actor, VBAD_MI_Actor::mi_port )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

const RTFieldDescriptor VBAD_MI_Actor::rtg_VBAD_MI_fields[] =
{
	// {{{RME classAttribute 'charIdTaskAtual'
	{
		"charIdTaskAtual"
	  , RTOffsetOf( VBAD_MI_Actor, charIdTaskAtual )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_char
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
	// {{{RME classAttribute 'charIdTaskOld'
  , {
		"charIdTaskOld"
	  , RTOffsetOf( VBAD_MI_Actor, charIdTaskOld )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_char
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
