// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::VBAD_RW'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VBAD_RW.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <VBAD_RW.h>
#include <MissionVant.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"rw_port"
	  , &VBAD_PInterface::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"status"
	  , &Status_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VBAD_RW_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VBAD_RW_Actor( _rts, _ref );
}

const RTActorClass VBAD_RW =
{
	(const RTActorClass *)0
  , "VBAD_RW"
  , (RTVersionId)0
  , 2
  , rtg_relays
  , new_VBAD_RW_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Waiting"
  , "READ"
  , "WRITE"
};

#define SUPER RTActor

VBAD_RW_Actor::VBAD_RW_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VBAD_RW_Actor::~VBAD_RW_Actor( void )
{
}

// {{{RME operation 'readData()'
void VBAD_RW_Actor::readData( void )
{
	// {{{USR

	// }}}USR
}
// }}}RME

// {{{RME operation 'writeData(char)'
void VBAD_RW_Actor::writeData( char cWrite )
{
	// {{{USR
	// armazenar o dado
	charDataRW = cWrite;

	// printar na tela
	printf("WRITTED: %c\n", charDataRW);
	// }}}USR
}
// }}}RME

int VBAD_RW_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// rw_port
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &rw_port;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 1:
		// status
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &status;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME enter ':TOP:READ'
INLINE_METHODS void VBAD_RW_Actor::enter3_READ( void )
{
	// {{{USR
	status.turnBusy(true).send();
	// }}}USR
}
// }}}RME

void VBAD_RW_Actor::enterStateV( void )
{
	switch( getCurrentState() )
	{
	case 3:
		enter3_READ();
		break;
	case 4:
		enter4_WRITE();
		break;
	default:
		RTActor::enterStateV();
		break;
	}
}

// {{{RME enter ':TOP:WRITE'
INLINE_METHODS void VBAD_RW_Actor::enter4_WRITE( void )
{
	// {{{USR
	status.turnBusy(true).send();
	// }}}USR
}
// }}}RME

// {{{RME exit ':TOP:READ'
INLINE_METHODS void VBAD_RW_Actor::exit3_READ( void )
{
	// {{{USR
	status.turnIdle(false).send();
	// }}}USR
}
// }}}RME

void VBAD_RW_Actor::exitStateV( void )
{
	switch( getCurrentState() )
	{
	case 3:
		exit3_READ();
		break;
	case 4:
		exit4_WRITE();
		break;
	default:
		RTActor::exitStateV();
		break;
	}
}

// {{{RME exit ':TOP:WRITE'
INLINE_METHODS void VBAD_RW_Actor::exit4_WRITE( void )
{
	// {{{USR
	status.turnIdle(false).send();
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Waiting:J434FD3FA00DB:t_read'
INLINE_METHODS void VBAD_RW_Actor::transition2_t_read( const char * rtdata, VBAD_PInterface::Conjugate * rtport )
{
	// {{{USR
	printf("\n\nMSG_RW: RW active...\n");
	printf("MSG_RW: Now reading...\n");

	// disparar o timer
	myTimer.informIn(RTTimespec(1,0));

	// chamar o mtodo
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Waiting:J434FD41900AB:t_write'
INLINE_METHODS void VBAD_RW_Actor::transition3_t_write( const char * rtdata, VBAD_PInterface::Conjugate * rtport )
{
	// {{{USR
	printf("\n\nMSG_RW: RW active...\n");
	printf("MSG_RW: Now writing...\n");

	// chamar o mtodo
	writeData(*rtdata);

	// disparar o timer
	myTimer.informIn(RTTimespec(1,0));
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:READ:J434FD43A0243:t_return_read'
INLINE_METHODS void VBAD_RW_Actor::transition4_t_return_read( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	// retornar o contexto
	rw_port.returnContext().send();
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:WRITE:J434FD44D038B:t_return_write'
INLINE_METHODS void VBAD_RW_Actor::transition5_t_return_write( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	// retornar o contexto
	rw_port.returnContext().send();
	// }}}USR
}
// }}}RME

INLINE_CHAINS void VBAD_RW_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void VBAD_RW_Actor::chain2_t_read( void )
{
	// transition ':TOP:Waiting:J434FD3FA00DB:t_read'
	rtgChainBegin( 2, "t_read" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_t_read( (const char *)msg->data, (VBAD_PInterface::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void VBAD_RW_Actor::chain3_t_write( void )
{
	// transition ':TOP:Waiting:J434FD41900AB:t_write'
	rtgChainBegin( 2, "t_write" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition3_t_write( (const char *)msg->data, (VBAD_PInterface::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void VBAD_RW_Actor::chain4_t_return_read( void )
{
	// transition ':TOP:READ:J434FD43A0243:t_return_read'
	rtgChainBegin( 3, "t_return_read" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition4_t_return_read( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void VBAD_RW_Actor::chain5_t_return_write( void )
{
	// transition ':TOP:WRITE:J434FD44D038B:t_return_write'
	rtgChainBegin( 4, "t_return_write" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition5_t_return_write( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void VBAD_RW_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Waiting'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'rw_port'
				switch( signalIndex )
				{
				case VBAD_PInterface::Conjugate::rti_activeRead:
					chain2_t_read();
					return;
				case VBAD_PInterface::Conjugate::rti_activeWrite:
					chain3_t_write();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:READ'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 2:
				// {{{RME port 'myTimer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain4_t_return_read();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME state ':TOP:WRITE'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 2:
				// {{{RME port 'myTimer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain5_t_return_write();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VBAD_RW_Actor::getActorData( void ) const
{
	return &VBAD_RW_Actor::rtg_class;
}

const RTActor_class VBAD_RW_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 4
  , VBAD_RW_Actor::rtg_parent_state
  , &VBAD_RW
  , 0
  , (const RTComponentDescriptor *)0
  , 3
  , VBAD_RW_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 1
  , VBAD_RW_Actor::rtg_VBAD_RW_fields
};

const RTStateId VBAD_RW_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 1
};

const RTPortDescriptor VBAD_RW_Actor::rtg_ports[] =
{
	{
		"rw_port"
	  , (const char *)0
	  , &VBAD_PInterface::Conjugate::rt_class
	  , RTOffsetOf( VBAD_RW_Actor, VBAD_RW_Actor::rw_port )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"myTimer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( VBAD_RW_Actor, VBAD_RW_Actor::myTimer )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"status"
	  , (const char *)0
	  , &Status_Protocol::Conjugate::rt_class
	  , RTOffsetOf( VBAD_RW_Actor, VBAD_RW_Actor::status )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

const RTFieldDescriptor VBAD_RW_Actor::rtg_VBAD_RW_fields[] =
{
	// {{{RME classAttribute 'charDataRW'
	{
		"charDataRW"
	  , RTOffsetOf( VBAD_RW_Actor, charDataRW )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_char
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
