// {{{RME classifier 'Logical View::VANT::VCNS::VCNS_Top'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VCNS_Top.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <VCNS_Top.h>
#include <COM_PROTOCOL.h>
#include <NAV_PROTOCOL.h>
#include <VIG_PROTOCOL.h>
extern const RTActorClass VCNS_Main;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"vig_to_bus"
	  , &VIG_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"com_to_bus"
	  , &COM_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"com_to_station"
	  , &COM_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"com_to_sat"
	  , &COM_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"nav_to_bus"
	  , &NAV_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VCNS_Top_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VCNS_Top_Actor( _rts, _ref );
}

const RTActorClass VCNS_Top =
{
	(const RTActorClass *)0
  , "VCNS_Top"
  , (RTVersionId)0
  , 5
  , rtg_relays
  , new_VCNS_Top_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vcns_main[] =
{
	{
		"to_intbus"
	  , 1
	}
  , {
		"com_to_bus"
	  , 1
	}
  , {
		"to_sat"
	  , 1
	}
  , {
		"to_station"
	  , 1
	}
  , {
		"to_bus"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vcns_main[] =
{
	{
		0
	  , &VIG_PROTOCOL::Base::rt_class
	}
  , {
		1
	  , &COM_PROTOCOL::Conjugate::rt_class
	}
  , {
		2
	  , &COM_PROTOCOL::Conjugate::rt_class
	}
  , {
		3
	  , &COM_PROTOCOL::Base::rt_class
	}
  , {
		4
	  , &NAV_PROTOCOL::Base::rt_class
	}
};

#define SUPER RTActor

VCNS_Top_Actor::VCNS_Top_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VCNS_Top_Actor::~VCNS_Top_Actor( void )
{
}

int VCNS_Top_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// vig_to_bus
		if( rtg_repIndex < 1 )
		{
			// vcns_main/to_intbus
			return vcns_main._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	case 1:
		// com_to_bus
		if( rtg_repIndex < 1 )
		{
			// vcns_main/com_to_bus
			return vcns_main._followIn( rtg_end, 1, rtg_repIndex );
		}
		break;
	case 2:
		// com_to_station
		if( rtg_repIndex < 1 )
		{
			// vcns_main/to_station
			return vcns_main._followIn( rtg_end, 3, rtg_repIndex );
		}
		break;
	case 3:
		// com_to_sat
		if( rtg_repIndex < 1 )
		{
			// vcns_main/to_sat
			return vcns_main._followIn( rtg_end, 2, rtg_repIndex );
		}
		break;
	case 4:
		// nav_to_bus
		if( rtg_repIndex < 1 )
		{
			// vcns_main/to_bus
			return vcns_main._followIn( rtg_end, 4, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VCNS_Top_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vcns_main
		switch( rtg_portId )
		{
		case 0:
			// to_intbus
			if( rtg_repIndex < 1 )
			{
				// vig_to_bus
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// com_to_bus
			if( rtg_repIndex < 1 )
			{
				// com_to_bus
				return _followOut( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 2:
			// to_sat
			if( rtg_repIndex < 1 )
			{
				// com_to_sat
				return _followOut( rtg_end, 3, rtg_repIndex );
			}
			break;
		case 3:
			// to_station
			if( rtg_repIndex < 1 )
			{
				// com_to_station
				return _followOut( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 4:
			// to_bus
			if( rtg_repIndex < 1 )
			{
				// nav_to_bus
				return _followOut( rtg_end, 4, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VCNS_Top_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VCNS_Top_Actor::getActorData( void ) const
{
	return &VCNS_Top_Actor::rtg_class;
}

const RTActor_class VCNS_Top_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VCNS_Top_Actor::rtg_parent_state
  , &VCNS_Top
  , 1
  , VCNS_Top_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VCNS_Top_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VCNS_Top_Actor::rtg_capsule_roles[] =
{
	{
		"vcns_main"
	  , &VCNS_Main
	  , RTOffsetOf( VCNS_Top_Actor, vcns_main )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 5
	  , rtg_interfaces_vcns_main
	  , 5
	  , rtg_bindings_vcns_main
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
