// {{{RME classifier 'Logical View::VANT::VCNS::VIG_PROTOCOL'

#ifndef VIG_PROTOCOL_H
#define VIG_PROTOCOL_H

#ifdef PRAGMA
#pragma interface "VIG_PROTOCOL.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <PMission.h>

struct VIG_PROTOCOL
{
	class Base : public PMission::Base
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_Image_Ready = rtiLast_PMission + 1 };

	protected:
		enum { rtiLast_VIG_PROTOCOL = rti_Image_Ready };

	public:
		inline RTInSignal Image_Ready( void );
		inline RTOutSignal Captar_Imagem( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public PMission::Conjugate
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_Captar_Imagem = rtiLast_PMission + 1 };

	protected:
		enum { rtiLast_VIG_PROTOCOL = rti_Captar_Imagem };

	public:
		inline RTInSignal Captar_Imagem( void );
		inline RTOutSignal Image_Ready( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline VIG_PROTOCOL::Base::Base( void )
	: PMission::Base()
{
}

inline VIG_PROTOCOL::Base::~Base( void )
{
}

inline RTInSignal VIG_PROTOCOL::Base::Image_Ready( void )
{
	return RTInSignal( this, rti_Image_Ready );
}

inline RTOutSignal VIG_PROTOCOL::Base::Captar_Imagem( void )
{
	return RTOutSignal( this, Conjugate::rti_Captar_Imagem, (const void *)0, &RTType_void );
}

inline VIG_PROTOCOL::Conjugate::Conjugate( void )
	: PMission::Conjugate()
{
}

inline VIG_PROTOCOL::Conjugate::~Conjugate( void )
{
}

inline RTInSignal VIG_PROTOCOL::Conjugate::Captar_Imagem( void )
{
	return RTInSignal( this, rti_Captar_Imagem );
}

inline RTOutSignal VIG_PROTOCOL::Conjugate::Image_Ready( void )
{
	return RTOutSignal( this, Base::rti_Image_Ready, (const void *)0, &RTType_void );
}

#endif /* VIG_PROTOCOL_H */

// }}}RME
