// {{{RME classifier 'Logical View::VANT::VSUP::VSEL::VSEL'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VSEL.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <VSEL.h>
#include <vsel_protocol.h>
extern const RTActorClass VSEL_Main;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"vsel_interface"
	  , &vsel_protocol::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VSEL_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VSEL_Actor( _rts, _ref );
}

const RTActorClass VSEL =
{
	(const RTActorClass *)0
  , "VSEL"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_VSEL_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vsel[] =
{
	{
		"vsel_interface"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vsel[] =
{
	{
		0
	  , &vsel_protocol::Conjugate::rt_class
	}
};

#define SUPER RTActor

VSEL_Actor::VSEL_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VSEL_Actor::~VSEL_Actor( void )
{
}

int VSEL_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// vsel_interface
		if( rtg_repIndex < 1 )
		{
			// vsel/vsel_interface
			return vsel._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VSEL_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vsel
		switch( rtg_portId )
		{
		case 0:
			// vsel_interface
			if( rtg_repIndex < 1 )
			{
				// vsel_interface
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VSEL_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VSEL_Actor::getActorData( void ) const
{
	return &VSEL_Actor::rtg_class;
}

const RTActor_class VSEL_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VSEL_Actor::rtg_parent_state
  , &VSEL
  , 1
  , VSEL_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VSEL_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VSEL_Actor::rtg_capsule_roles[] =
{
	{
		"vsel"
	  , &VSEL_Main
	  , RTOffsetOf( VSEL_Actor, vsel )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vsel
	  , 1
	  , rtg_bindings_vsel
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
