// {{{RME classifier 'Logical View::VANT::Common::stubEC'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "stubEC.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <stubEC.h>
#include <MissionVant.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"ec"
	  , &COM_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_stubEC_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new stubEC_Actor( _rts, _ref );
}

const RTActorClass stubEC =
{
	(const RTActorClass *)0
  , "stubEC"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_stubEC_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "sendMission"
};

#define SUPER RTActor

stubEC_Actor::stubEC_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
	, intMission( 0 )
{
}

stubEC_Actor::~stubEC_Actor( void )
{
}

int stubEC_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// ec
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &ec;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME enter ':TOP:sendMission'
INLINE_METHODS void stubEC_Actor::enter2_sendMission( void )
{
	// {{{USR
	// instanciar a classe
	MissionVant myMission;

	// incrementar a missao
	intMission++;

	// atribuir valores comuns da missao
	myMission.Altitude = 2000; 
	myMission.Latitude = 23;  
	myMission.Longitude = 20;
	myMission.Missao= false;
	myMission.Image= 0;

	if (intMission==2){
		// missao de ataque
		myMission.Missao= 1;
	}

	// enviar a misso
	ec.sendMission(myMission).send();

	// timer
	if (intMission<=2)
		timer.informIn(RTTimespec(10,0));
	// }}}USR
}
// }}}RME

void stubEC_Actor::enterStateV( void )
{
	switch( getCurrentState() )
	{
	case 2:
		enter2_sendMission();
		break;
	default:
		RTActor::enterStateV();
		break;
	}
}

INLINE_CHAINS void stubEC_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void stubEC_Actor::chain2_timeout( void )
{
	// transition ':TOP:sendMission:J438744F20282:timeout'
	rtgChainBegin( 2, "timeout" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

void stubEC_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:sendMission'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 2:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain2_timeout();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * stubEC_Actor::getActorData( void ) const
{
	return &stubEC_Actor::rtg_class;
}

const RTActor_class stubEC_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , stubEC_Actor::rtg_parent_state
  , &stubEC
  , 0
  , (const RTComponentDescriptor *)0
  , 2
  , stubEC_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 1
  , stubEC_Actor::rtg_stubEC_fields
};

const RTStateId stubEC_Actor::rtg_parent_state[] =
{
	0
  , 1
};

const RTPortDescriptor stubEC_Actor::rtg_ports[] =
{
	{
		"ec"
	  , (const char *)0
	  , &COM_PROTOCOL::Base::rt_class
	  , RTOffsetOf( stubEC_Actor, stubEC_Actor::ec )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( stubEC_Actor, stubEC_Actor::timer )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
};

const RTFieldDescriptor stubEC_Actor::rtg_stubEC_fields[] =
{
	// {{{RME classAttribute 'intMission'
	{
		"intMission"
	  , RTOffsetOf( stubEC_Actor, intMission )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_int
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
