// {{{RME classifier 'Logical View::VANT::VSUP::Common_VSUP::vsel_protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "vsel_protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <vsel_protocol.h>

const RTProtocolDescriptor vsel_protocol::Base::rt_class =
{
	&vbad_inheritance::Base::rt_class
  , &vsel_protocol::Conjugate::rt_class
  , "vsel_protocol"
  , 0
  , 3
  , vsel_protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor vsel_protocol::Base::rt_signals[] =
{
	{
		"informCarga"
	  , &RTType_int
	  , vsel_protocol::Base::rti_informCarga
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , vsel_protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , vsel_protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor vsel_protocol::Conjugate::rt_class =
{
	&vbad_inheritance::Conjugate::rt_class
  , &vsel_protocol::Base::rt_class
  , "vsel_protocol"
  , 0
  , 4
  , vsel_protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor vsel_protocol::Conjugate::rt_signals[] =
{
	{
		"read"
	  , &RTType_char
	  , vsel_protocol::Conjugate::rti_read
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , vsel_protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , vsel_protocol::Conjugate::rti_rtUnbound
	}
  , {
		"write"
	  , &RTType_char
	  , vsel_protocol::Conjugate::rti_write
	}
};

// }}}RME
