// {{{RME classifier 'Logical View::VANT::VSUP::Common_VSUP::vsel_protocol'

#ifndef vsel_protocol_H
#define vsel_protocol_H

#ifdef PRAGMA
#pragma interface "vsel_protocol.h"
#endif

#include <RTSystem/VANT_EC_SAT.h>
#include <vbad_inheritance.h>

struct vsel_protocol
{
	class Base : public vbad_inheritance::Base
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_informCarga = rtiLast_vbad_inheritance + 1 };

	protected:
		enum { rtiLast_vsel_protocol = rti_informCarga };

	public:
		inline RTInSignal informCarga( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public vbad_inheritance::Conjugate
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );

	protected:
		enum { rtiLast_vsel_protocol = rtiLast_vbad_inheritance };

	public:
		inline RTOutSignal informCarga( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline vsel_protocol::Base::Base( void )
	: vbad_inheritance::Base()
{
}

inline vsel_protocol::Base::~Base( void )
{
}

inline RTInSignal vsel_protocol::Base::informCarga( void )
{
	return RTInSignal( this, rti_informCarga );
}

inline vsel_protocol::Conjugate::Conjugate( void )
	: vbad_inheritance::Conjugate()
{
}

inline vsel_protocol::Conjugate::~Conjugate( void )
{
}

inline RTOutSignal vsel_protocol::Conjugate::informCarga( const int & data )
{
	return RTOutSignal( this, Base::rti_informCarga, &data, &RTType_int );
}

#endif /* vsel_protocol_H */

// }}}RME
